import { world, system } from "@minecraft/server";
import { ActionFormData } from '@minecraft/server-ui'

system.events.beforeWatchdogTerminate.subscribe(data => {
	data.cancel = true;
});


let time = 0;

world.events.itemStartCharge.subscribe((use) =>{
	let p = use.source;
	let bow = "_bow";
	let item = use.itemStack.typeId;
	if(item.toLowerCase().includes(bow)){
		p.addTag("using");
	}
});

world.events.itemStopCharge.subscribe((stop) =>{
	let p = stop.source;
	let bow = "_bow";
	let item = stop.itemStack.typeId;
	if(item.toLowerCase().includes(bow)){
		p.removeTag("using");
		p.runCommandAsync(`scoreboard players set @s using 0`);
		time = 0;
	}

})

system.run(tickFunction);

function tickFunction() {
	let w = world.getDimension("overworld"); 

	for (let p of world.getPlayers()) {
		let container = p.getComponent("inventory").container;
		let hand = container.getItem(p.selectedSlot);


		if(p.hasComponent("health").current == 0){
			p.runCommandAsync(`scoreboard players set @s using 0`);
			time = 0;
			p.removeTag("using");
			p.removeTag("ambar_bow");
			p.removeTag("jade_bow");
			p.removeTag("ruby_bow");
			p.removeTag("sapphire_bow");
			p.removeTag("platino_bow");
			p.removeTag("uranium_bow");
			p.removeTag("topacio_bow");
			p.removeTag("flourite_bow");
			p.removeTag("onix_bow");
		}
		p.runCommandAsync(`function arrow`)
		if(p.hasTag("using")){
			if(p.hasTag("ambar_bow") && hand.typeId == "new:ambar_bow"){
				time++;
			}
			if(p.hasTag("jade_bow") && hand.typeId == "new:jade_bow"){
				time++;
			}
			if(p.hasTag("ruby_bow") && hand.typeId == "new:ruby_bow"){
				time++;
			}
			if(p.hasTag("sapphire_bow") && hand.typeId == "new:sapphire_bow"){
				time++;
			}
			if(p.hasTag("platino_bow") && hand.typeId == "new:platino_bow"){
				time++;
			}
			if(p.hasTag("uranium_bow") && hand.typeId == "new:uranium_bow"){
				time++;
			}
			if(p.hasTag("topacio_bow") && hand.typeId == "new:topacio_bow"){
				time++;
			}
			if(p.hasTag("flourite_bow") && hand.typeId == "new:flourite_bow"){
				time++;
			}
			if(p.hasTag("onix_bow") && hand.typeId == "new:onix_bow"){
				time++;
			}


			if(time >= 1 && time < 5){
				p.runCommandAsync(`scoreboard players set @s using 1`);
			}
			if(time >= 5 && time < 10){
				p.runCommandAsync(`scoreboard players set @s using 2`);
			}
			if(time >= 10){
				p.runCommandAsync(`scoreboard players set @s using 3`);
			}
		}




		if (p.hasTag("interact")){
			const form = new ActionFormData()
			.title("Advanced Enchantment Table")
			
			.button("Enchant I\n10 Levels",`textures/items/tools/topacio_sword`)
			.button("Enchant II\n20 Levels",`textures/items/tools/ruby_sword`)
			.button("Enchant III\n30 Levels",`textures/items/tools/ambar_sword`)
			form.show(p).then(response => {
				p.removeTag("interact")
				if (!response.isCanceled && response.selection != 3) {
					let item = p.getComponent("inventory").container.getItem(p.selectedSlot)
					if (item){
						enchant(p,item,response.selection+1)
					}
				}
			})
		}

		p.runCommandAsync(`function rings_function`);

		if(p.getComponent('health').current <= 0){
			p.runCommandAsync(`scoreboard players set @s ambar_totem 0`)
		}

		try{
			let item = p.getComponent("inventory").container.getItem(p.selectedSlot);
			if(item){
				let lore = item.getLore()
				if (lore[0].includes("Haste I")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Haste")+8,lore[0].indexOf(" ",lore[0].indexOf("Haste")+8)))
					p.runCommandAsync(`effect @s haste 1 0 true`)
				}
				if (lore[0].includes("Haste II")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Haste")+8,lore[0].indexOf(" ",lore[0].indexOf("Haste")+8)))
					p.runCommandAsync(`effect @s haste 1 1 true`)
				}
				if (lore[0].includes("Haste III")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Haste")+8,lore[0].indexOf(" ",lore[0].indexOf("Haste")+8)))
					p.runCommandAsync(`effect @s haste 1 2 true`)
				}
			}
		}
		catch(e){
		}

		p.runCommandAsync(`function shield`);

		let shield_o_m = ["sapphire_offhand", "ruby_offhand", "iron_offhand", "netherite_offhand", "diamond_offhand", "copper_offhand", "onix_offhand", "uranium_offhand", "flourite_offhand",    "sapphire_mainhand", "ruby_mainhand", "onix_mainhand", "uranium_mainhand", "flourite_mainhand",   "platino_offhand", "rodio_offhand", "ambar_offhand", "topacio_offhand", "jade_offhand",    "platino_mainhand", "iron_mainhand", "diamond_mainhand", "netherite_mainhand", "copper_mainhand", "rodio_mainhand", "topacio_mainhand", "jade_mainhand", "ambar_mainhand"]

		for(let s_m_o of shield_o_m){
			if (!p.hasTag(s_m_o)) {
				p.removeTag("sapphire_shield");
				p.removeTag("jade_shield");
				p.removeTag("flourite_shield");
				p.removeTag("ruby_shield");
				p.removeTag("onix_shield");
				p.removeTag("uranium_shield");
				p.runCommandAsync(`effect @s resistance 0 0 true`)
				p.removeTag("ambar_shield");
				p.removeTag("platino_shield");
				p.removeTag("rodio_shield");
				p.removeTag("topacio_shield");
				p.removeTag("iron_shield");
				p.removeTag("diamond_shield");
				p.removeTag("netherite_shield");
				p.removeTag("copper_shield");
			}
		}

		//Shield Using
		if(p.hasTag("attack")){
			p.runCommandAsync(`effect @s resistance 0 0 true`);
		}
		if(p.isSneaking && !p.hasTag("attack")){
			if (p.hasTag("iron_offhand") || p.hasTag("iron_mainhand")) {
				p.addTag("iron_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("netherite_offhand") || p.hasTag("netherite_mainhand")) {
				p.addTag("netherite_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("copper_offhand") || p.hasTag("copper_mainhand")) {
				p.addTag("copper_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("diamond_offhand") || p.hasTag("diamond_mainhand")) {
				p.addTag("diamond_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}

			if (p.hasTag("sapphire_offhand") || p.hasTag("sapphire_mainhand")) {
				p.addTag("sapphire_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("jade_offhand") || p.hasTag("jade_mainhand")) {
				p.addTag("jade_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("flourite_offhand") || p.hasTag("flourite_mainhand")) {
				p.addTag("flourite_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("ruby_offhand") || p.hasTag("ruby_mainhand")) {
				p.addTag("ruby_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("onix_offhand") || p.hasTag("onix_mainhand")) {
				p.addTag("onix_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("uranium_offhand") || p.hasTag("uranium_mainhand")) {
				p.addTag("uranium_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("platino_offhand") || p.hasTag("platino_mainhand")) {
				p.addTag("platino_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("ambar_offhand") || p.hasTag("ambar_mainhand")) {
				p.addTag("ambar_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("topacio_offhand") || p.hasTag("topacio_mainhand")) {
				p.addTag("topacio_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);

			}
			if (p.hasTag("rodio_offhand") || p.hasTag("rodio_mainhand")) {
				p.addTag("rodio_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
		}
		if(!p.isSneaking){
			if (!p.hasTag("diamond_offhand") && !p.hasTag("diamond_mainhand")) {
				p.removeTag("diamond_shield");
			}
			if (!p.hasTag("iron_offhand") && !p.hasTag("iron_mainhand")) {
				p.removeTag("iron_shield");
			}
			if (!p.hasTag("netherite_offhand") && !p.hasTag("netherite_mainhand")) {
				p.removeTag("netherite_shield");
			}
			if (!p.hasTag("copper_offhand") && !p.hasTag("copper_mainhand")) {
				p.removeTag("copper_shield");
			}

			if (!p.hasTag("sapphire_offhand") && !p.hasTag("sapphire_mainhand")) {
				p.removeTag("sapphire_shield");
			}
			if (!p.hasTag("flourite_offhand") && !p.hasTag("flourite_mainhand")) {
				p.removeTag("flourite_shield");
			}
			if (p.hasTag("jade_offhand") || p.hasTag("jade_mainhand")) {
				p.removeTag("jade_shield");
			}
			if (!p.hasTag("ruby_offhand") && !p.hasTag("ruby_mainhand")) {
				p.removeTag("ruby_shield");
			}
			if (!p.hasTag("onix_offhand") && !p.hasTag("onix_mainhand")) {
				p.removeTag("onix_shield");
			}
			if (!p.hasTag("uranium_offhand") && !p.hasTag("uranium_mainhand")) {
				p.removeTag("uranium_shield");
			}
			if (!p.hasTag("rodio_offhand") && !p.hasTag("rodio_mainhand")) {
				p.removeTag("rodio_shield");
			}
			if (!p.hasTag("ambar_offhand") && !p.hasTag("ambar_mainhand")) {
				p.removeTag("ambar_shield");
			}
			if (!p.hasTag("topacio_offhand") && !p.hasTag("topacio_mainhand")) {
				p.removeTag("topacio_shield");
			}
			if (!p.hasTag("platino_offhand") && !p.hasTag("platino_mainhand")) {
				p.removeTag("platino_shield");
			}
		}
	}
	system.run(tickFunction);
}


world.events.entityHurt.subscribe(hurt =>{

	let eHurt = hurt.hurtEntity;
	let damaging = hurt.damageSource;

	if(eHurt.hasTag("ambar_totem2") || eHurt.hasTag("ambar_totem1")){
		if(eHurt.typeId == "minecraft:player" && hurt.damageSource.cause == "entityAttack"){
			let random_totem = Math.floor(Math.random() * 100);

			if(random_totem >= 41){
				eHurt.runCommandAsync(`function totem_function`);

			}
			if(random_totem >= 16 && random_totem <= 40){


			}
			if(random_totem <= 15){
				eHurt.runCommandAsync(`clear @s new:ambar_totem 0 1`);
				eHurt.runCommandAsync(`playsound random.break @s`)
			}
		}
	}
	

	try{
		if (damaging.typeId == "minecraft:player"){
			let item = damaging.getComponent("inventory").container.getItem(damaging.selectedSlot);
			if(item){
				let lore = item.getLore()
				if (lore[0].includes("Poison")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Poison")+7,lore[0].indexOf(" ",lore[0].indexOf("Poison")+7)))
					eHurt.runCommandAsync(`effect @s poison ${level*3} ${level-1}`)
				}
				if (lore[0].includes("Levitating")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Levitating")+11,lore[0].indexOf(" ",lore[0].indexOf("Levitating")+11)))
					eHurt.runCommandAsync(`effect @s levitation 2 ${(level*2)+3}`)
				}
				if (lore[0].includes("Vampire")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Vampire")+10,lore[0].indexOf(" ",lore[0].indexOf("Vampire")+10)))
					damaging.runCommandAsync(`effect @s regeneration ${level+2} ${level-1}`)
				}
				if (lore[0].includes("Whiter")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Whiter")+10,lore[0].indexOf(" ",lore[0].indexOf("Whiter")+10)))
					damaging.runCommandAsync(`effect @s wither ${level+2} ${level-1}`)
				}
				if (lore[0].includes("Ice Aspect")){
					let level = enchantedLevel(lore[0].substring(lore[0].indexOf("Ice Aspect")+8,lore[0].indexOf(" ",lore[0].indexOf("Ice Aspect")+8)))
					eHurt.runCommandAsync(`effect @s slowness ${level*2} ${level}`)
				}

			}
		}
	}catch(e){

	}

	if(eHurt.typeId == "minecraft:player"){
		if(damaging.cause == "projectile" || damaging.cause == "entityAttack" || damaging.cause == "entityExplosion" || damaging.cause == "blockExplosion"){
			if(eHurt.hasTag("iron_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);

			}
			if(eHurt.hasTag("diamond_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);

			}
			if(eHurt.hasTag("netherite_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);

			}
			if(eHurt.hasTag("copper_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);

			}

			if(eHurt.hasTag("sapphire_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				

			}
			if(eHurt.hasTag("jade_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				
			}

			if(eHurt.hasTag("flourite_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				
			}

			if(eHurt.hasTag("ruby_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				
			}

			if(eHurt.hasTag("onix_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				
			}

			if(eHurt.hasTag("uranium_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.uranium_shield @s ~~~`);
				
			}

			if(eHurt.hasTag("platino_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.metal_shield @s ~~~`);
				
			}
			if(eHurt.hasTag("ambar_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.ambar_shield @s ~~~`);
				
			}
			if(eHurt.hasTag("rodio_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.metal_shield @s ~~~`);
				
			}
			if(eHurt.hasTag("topacio_shield")){
				eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
				eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);
				eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
				
			}
		}
	}
	try{
		
		if(eHurt.typeId == "minecraft:player" && !eHurt.hasTag("sapphire_shield") && !eHurt.hasTag("flourite_shield") && !eHurt.hasTag("ruby_shield") && !eHurt.hasTag("onix_shield") && !eHurt.hasTag("uranium_shield") && !eHurt.hasTag("ambar_shield") && !eHurt.hasTag("topacio_shield") && !eHurt.hasTag("platino_shield") && !eHurt.hasTag("rodio_shield") && !eHurt.hasTag("jade_shield") && !eHurt.hasTag("iron_shield") && !eHurt.hasTag("diamond_shield") && !eHurt.hasTag("netherite_shield") && !eHurt.hasTag("copper_shield")){

			eHurt.runCommandAsync(`playsound game.player.hurt @p ~~~ 4 1 4`)
		}

		if(damaging.hasTag("iron_shield") ||damaging.hasTag("diamond_shield") ||damaging.hasTag("netherite_shield") ||damaging.hasTag("copper_shield") ||damaging.hasTag("sapphire_shield") || damaging.hasTag("flourite_shield") || damaging.hasTag("ruby_shield") || damaging.hasTag("onix_shield") || damaging.hasTag("uranium_shield") || damaging.hasTag("ambar_shield") || damaging.hasTag("topacio_shield") || damaging.hasTag("platino_shield") || damaging.hasTag("rodio_shield") || damaging.hasTag("jade_shield")){
			damaging.runCommandAsync(`tag @s add attack`);
		}
	}
	catch(e){
	}


})



world.events.entityHit.subscribe(v=>{
	let block = v.hitBlock;

	let player = v.entity

	let id = block.typeId;

	let ore =[
		"iron_ore",
		"gold_ore",
		"copper_ore",
		"rodio_ore",
		"platino_ore",
		"ambar_ore",
		"uranium_ore"
		]

	if(!id.includes(ore)){
		v.entity.removeTag("iron");
		v.entity.removeTag("gold");
		v.entity.removeTag("copper");
		v.entity.removeTag("ambar");
		v.entity.removeTag("uranium");
		v.entity.removeTag("rodio");
		v.entity.removeTag("platino")
	}

	if(id.includes("iron_ore")){
		v.entity.runCommandAsync(`tag @s add iron`)
	}
	if(id.includes("gold_ore")){
		v.entity.runCommandAsync(`tag @s add gold`)
	}
	if(id.includes("copper_ore")){
		v.entity.runCommandAsync(`tag @s add copper`)
	}
	if(id.includes("platino_ore")){
		v.entity.runCommandAsync(`tag @s add platino`)
	}
	if(id.includes("rodio_ore")){
		v.entity.runCommandAsync(`tag @s add rodio`)
	}
	if(id.includes("ambar_ore")){
		v.entity.runCommandAsync(`tag @s add ambar`)
	}
	if(id.includes("uranium_ore")){
		v.entity.runCommandAsync(`tag @s add uranium`)
	}
})

world.events.blockBreak.subscribe(b=>{
	let p = b.player;
	let block = b.block;

	let location = [
		b.block.location.x,
		b.block.location.y,
		b.block.location.z
		];


	let item = p.getComponent("inventory").container.getItem(p.selectedSlot);
	try{
		if(item){
			let lore = item.getLore()
			if(lore[0].includes("Smelthing I")){
				if(p.hasTag("iron")){
					p.removeTag("iron");
					p.runCommandAsync(`summon new:iron ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("gold")){
					p.removeTag("gold");
					p.runCommandAsync(`summon new:gold ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("copper")){
					p.removeTag("copper");
					p.runCommandAsync(`summon new:copper ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
			}
			if(lore[0].includes("Smelthing II")){
				if(p.hasTag("iron")){
					p.removeTag("iron");
					p.runCommandAsync(`summon new:iron ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("gold")){
					p.removeTag("gold");
					p.runCommandAsync(`summon new:gold ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("platino")){
					p.removeTag("platino");
					p.runCommandAsync(`summon new:platino2 ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("rodio")){
					p.removeTag("rodio");
					p.runCommandAsync(`summon new:rodio2 ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("copper")){
					p.removeTag("copper");
					p.runCommandAsync(`summon new:copper ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
			}
			if(lore[0].includes("Smelthing III")){
				if(p.hasTag("iron")){
					p.removeTag("iron");
					p.runCommandAsync(`summon new:iron ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("gold")){
					p.removeTag("gold");
					p.runCommandAsync(`summon new:gold ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("platino")){
					p.removeTag("platino");
					p.runCommandAsync(`summon new:platino2 ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("rodio")){
					p.removeTag("rodio");
					p.runCommandAsync(`summon new:rodio2 ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("uranium")){
					p.removeTag("uranium");
					p.runCommandAsync(`summon new:uranium ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("copper")){
					p.removeTag("copper");
					p.runCommandAsync(`summon new:copper ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
				if(p.hasTag("ambar")){
					p.removeTag("ambar");
					p.runCommandAsync(`summon new:ambar ${location[0]} ${location[1]} ${location[2]}`);
					p.runCommandAsync(`playsound fire.ignite @s`)
				}
			}
			//axe
			if (lore[0].includes("Woodcutter I")){
				p.runCommandAsync(`summon new:axe ${location[0]} ${location[1] + 1} ${location[2]} new:axe_function`);
			}
			if (lore[0].includes("Woodcutter II")){
				p.runCommandAsync(`summon new:axe ${location[0]} ${location[1] + 1} ${location[2]} new:axe_function4`);
			}
			if (lore[0].includes("Woodcutter III")){
				p.runCommandAsync(`summon new:axe ${location[0]} ${location[1] + 1} ${location[2]} new:axe_function5`);
			}
		}
	}catch(e){

	}
});

function enchantedLevel(enchanted_num){
	if (enchanted_num == "I"){
		return 1
	}
	else if (enchanted_num == "II"){
		return 2
	}
	else if (enchanted_num == "III"){
		return 3
	}
	else{
		return 1
	}
}

function enchant(player,item,level){
	if (player.hasTag(`xp${level}`)){
		let lore = ""
		let itemlore = item.getLore()[0]
		if (!itemlore){
			itemlore=""
		}
		let count = 0
		let levelid = "I"
		if(level == 1){
			levelid = "I"
		}
		else if(level == 2){
			levelid = "II"
		}
		else if(level == 3){
			levelid = "III"
		}
		while (lore == "" && count < 30){
			let random = Math.floor(Math.random()*120)
			count = count + 1
			if(item.typeId.includes("sword") || item.typeId.includes("_axe") || item.typeId.includes("battleaxe")){
				if (random <= 20 && !itemlore.includes("Poison")){
					lore = "\n§2Poison "+levelid+" "
				}
				else if (random > 40 && random<=60 && !itemlore.includes("Ice Aspect")){
					lore = "\n§3Ice Aspect "+levelid+" "
				}
				else if (random > 60 && random<=80 && !itemlore.includes("Levitating")){
					lore = "\n§7Levitating "+levelid+" "
				}
				else if (random > 80 && random<=100 && !itemlore.includes("Vampire")){
					lore = "\n§4Vampire "+levelid+" "
				}
				else if (random > 80 && random<=100 && !itemlore.includes("Wither")){
					lore = "\n§8Wither "+levelid+" "
				}
				if(item.typeId.includes("_axe")){
					if (random <= 20 && !itemlore.includes("Woodcutter")){
						lore = "\n§bWoodcutter "+levelid+" "
					}
					if (random > 20 && random <=50 && !itemlore.includes("Haste")){
						lore = "\n§3Haste "+levelid+" "
					}
				}
			}
			if(item.typeId.includes("pickaxe")){
				if (random <= 30 && !itemlore.includes("Smelthing")){
					lore = "\n§6Smelthing "+levelid+" "
				}
				else if (random > 60 && random<=100 && !itemlore.includes("Haste")){
					lore = "\n§3Haste "+levelid+" "
				}
			}
			if(item.typeId.includes("hammer")){
				if (!itemlore.includes("Haste")){
					lore = "\n§3Haste "+levelid+" "
				}
			}
		}
		if (!lore == ""){
			item.setLore([itemlore + lore])
			player.getComponent("inventory").container.setItem(player.selectedSlot,item)
			if (level-1 <= 4){
				player.runCommandAsync(`xp -${(level)*10}L @p`)
			}
			else{
				player.runCommandAsync(`xp -${((level-5)*5)+50}L @p`)
			}
		}
	}
}

function getItems(inventory) {
	let items = [];
	if (inventory.size) {
		for (let i = 0; i < inventory.size; i++) {
			items.push(inventory.getItem(i));
		}
	} else if (!inventory.size && inventory.container) {
		for (let i = 0; i < inventory.container.size; i++) {
			items.push(inventory.container.getItem(i));
		}
	}
	return items;
}

function findItem(items, item) {
	try {
		let res;

		if (item.amount == '*') {
			res = items.filter(it => it && item.typeId == it.id);
		} else {
			res = items.filter(it => it && item.typeId == it.id && item.amount == it.amount);
		}
		return res.length > 0 ? items.indexOf(res[0]) : -1;

	} catch (e) {}
}


